Subject: bug#22817: Fwd: bug#22817: 25.0.91; [PATCH] Include versioned preloaded libraries in `package--builtin-versions'

From: Chris Feng <[email-masked]>
Date: Tue, 12 Jul 2016 22:28:23 +0800

>> Also, since `package--builtin-versions' is now complete, should we remove the
>> version info in `package--builtins'?
>
> Not sure what you mean nor what would be the benefit.

I just noticed you wrote this in finder.el:

    ;; FIXME: Now that we have package--builtin-versions, package--builtins is
    ;; only needed to get the list of unversioned packages and to get the
    ;; summary description of each package.

>> I forgot to mention that the bug can be reproduced by installing a
>> package having a preloaded lib as a dependency, e.g.:
>>
>>   M-x package-install RET xelb RET
>>
>> Then cl-generic 0.2 will get installed.
>
> A more direct way is to check (assq 'cl-generic package--builtin-versions)
> which should not return nil (but does :-( ).
>
> I haven't looked in detail at your patch, but it'd be good to do
> something along these lines.
>
> It's probably too late to use your approach for emacs-25, but I think we
> need to install some fix for this problem in emacs-25, since otherwise
> Emacs-25.1 will end up insisting on installing cl-generic from GNU ELPA
> every occasion it gets.
>
> How 'bout you install your patch into master and we install the patch
> below into emacs-25?

That'd be okay.

Chris